# Player Settings

Operations dealing with video player settings for videos and channels.

## Get video player settings

`GET /api/v1/player-settings/videos/{id}`

Get player settings for a specific video. Returns video-specific settings merged with channel player settings.

Authentication: no security requirement declared for this operation.

Parameters:

- `id` (path, id | UUIDv4 | shortUUID, required) - The object id, uuid or short uuid
  Type: id | UUIDv4 | shortUUID
  
  oneOf:
    Reference: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md); Type: id
    
    minimum: 1
    
    Example:
    
    ```json
    42
    ```
  
    Reference: [UUIDv4](https://docs.joinpeertube.org/api-rest-reference/api/models/uuidv4.md); Type: UUIDv4, uuid
    
    minLength: 36
    
    maxLength: 36
    
    pattern: "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$"
    
    Example:
    
    ```json
    "9c9de5e8-0a1e-484a-b099-e80766180a6d"
    ```
  
    Reference: [shortUUID](https://docs.joinpeertube.org/api-rest-reference/api/models/shortuuid.md); Type: shortUUID
    
    translation of a uuid v4 with a bigger alphabet to have a shorter uuid
    
    Example:
    
    ```json
    "2y84q2MQUMWPbiEcxNXMgC"
    ```

- `raw` (query, boolean, optional) - Return raw settings without merging channel defaults
  Type: boolean
  
  default: false

Responses:

- 200: successful operation

Content type: application/json

Type: PlayerVideoSettings

Player settings for a video

Schema: [PlayerVideoSettings](https://docs.joinpeertube.org/api-rest-reference/api/models/playervideosettings.md)

- `theme` (optional)
  Reference: [PlayerThemeVideoSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemevideosetting.md); Type: PlayerThemeVideoSetting
  
  Player theme setting for a video:
    - `channel-default` Use the channel default theme
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["channel-default","instance-default","galaxy","lucide"]

- 404: video not found

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/player-settings/videos/42?raw=false'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/player-settings/videos/42?raw=false', {
  method: 'GET',
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get('https://peertube2.cpy.re/api/v1/player-settings/videos/42?raw=false')
print(response.text)
```


## Update video player settings

`PUT /api/v1/player-settings/videos/{id}`

Update player settings for a specific video

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `id` (path, id | UUIDv4 | shortUUID, required) - The object id, uuid or short uuid
  Type: id | UUIDv4 | shortUUID
  
  oneOf:
    Reference: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md); Type: id
    
    minimum: 1
    
    Example:
    
    ```json
    42
    ```
  
    Reference: [UUIDv4](https://docs.joinpeertube.org/api-rest-reference/api/models/uuidv4.md); Type: UUIDv4, uuid
    
    minLength: 36
    
    maxLength: 36
    
    pattern: "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$"
    
    Example:
    
    ```json
    "9c9de5e8-0a1e-484a-b099-e80766180a6d"
    ```
  
    Reference: [shortUUID](https://docs.joinpeertube.org/api-rest-reference/api/models/shortuuid.md); Type: shortUUID
    
    translation of a uuid v4 with a bigger alphabet to have a shorter uuid
    
    Example:
    
    ```json
    "2y84q2MQUMWPbiEcxNXMgC"
    ```

Request body: application/json

Type: PlayerVideoSettingsUpdate

Player settings update for a video

Schema: [PlayerVideoSettingsUpdate](https://docs.joinpeertube.org/api-rest-reference/api/models/playervideosettingsupdate.md)

- `theme` (required)
  Reference: [PlayerThemeVideoSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemevideosetting.md); Type: PlayerThemeVideoSetting
  
  Player theme setting for a video:
    - `channel-default` Use the channel default theme
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["channel-default","instance-default","galaxy","lucide"]

Responses:

- 200: successful operation

Content type: application/json

Type: PlayerVideoSettings

Player settings for a video

Schema: [PlayerVideoSettings](https://docs.joinpeertube.org/api-rest-reference/api/models/playervideosettings.md)

- `theme` (optional)
  Reference: [PlayerThemeVideoSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemevideosetting.md); Type: PlayerThemeVideoSetting
  
  Player theme setting for a video:
    - `channel-default` Use the channel default theme
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["channel-default","instance-default","galaxy","lucide"]

- 404: video not found

## Examples

### cURL

```bash
curl -X PUT 'https://peertube2.cpy.re/api/v1/player-settings/videos/42' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "theme": "channel-default"
}'
```

### JavaScript

```javascript
const body = `{
  "theme": "channel-default"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/player-settings/videos/42', {
  method: 'PUT',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "theme": "channel-default"
}'''

response = requests.put(
    'https://peertube2.cpy.re/api/v1/player-settings/videos/42',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Get channel player settings

`GET /api/v1/player-settings/video-channels/{channelHandle}`

Get player settings for a video channel.

Authentication: no security requirement declared for this operation.

Parameters:

- `channelHandle` (path, string, required) - The video channel handle
  Type: string
  
  Example:
  
  ```json
  "my_username | my_username@example.com"
  ```

- `raw` (query, boolean, optional) - Return raw settings without applying instance defaults
  Type: boolean
  
  default: false

Responses:

- 200: successful operation

Content type: application/json

Type: PlayerChannelSettings

Player settings for a channel

Schema: [PlayerChannelSettings](https://docs.joinpeertube.org/api-rest-reference/api/models/playerchannelsettings.md)

- `theme` (optional)
  Reference: [PlayerThemeChannelSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemechannelsetting.md); Type: PlayerThemeChannelSetting
  
  Player theme setting for a channel:
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["instance-default","galaxy","lucide"]

- 404: video channel not found

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com?raw=false'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com?raw=false', {
  method: 'GET',
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get('https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com?raw=false')
print(response.text)
```


## Update channel player settings

`PUT /api/v1/player-settings/video-channels/{channelHandle}`

Update default player settings for a video channel.

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `channelHandle` (path, string, required) - The video channel handle
  Type: string
  
  Example:
  
  ```json
  "my_username | my_username@example.com"
  ```

Request body: application/json

Type: PlayerChannelSettingsUpdate

Player settings update for a channel

Schema: [PlayerChannelSettingsUpdate](https://docs.joinpeertube.org/api-rest-reference/api/models/playerchannelsettingsupdate.md)

- `theme` (required)
  Reference: [PlayerThemeChannelSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemechannelsetting.md); Type: PlayerThemeChannelSetting
  
  Player theme setting for a channel:
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["instance-default","galaxy","lucide"]

Responses:

- 200: successful operation

Content type: application/json

Type: PlayerChannelSettings

Player settings for a channel

Schema: [PlayerChannelSettings](https://docs.joinpeertube.org/api-rest-reference/api/models/playerchannelsettings.md)

- `theme` (optional)
  Reference: [PlayerThemeChannelSetting](https://docs.joinpeertube.org/api-rest-reference/api/models/playerthemechannelsetting.md); Type: PlayerThemeChannelSetting
  
  Player theme setting for a channel:
    - `instance-default` Use the instance default theme
    - `galaxy` Use the galaxy theme
    - `lucide` Use the lucide theme
  
  
  enum: ["instance-default","galaxy","lucide"]

- 404: video channel not found

## Examples

### cURL

```bash
curl -X PUT 'https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "theme": "instance-default"
}'
```

### JavaScript

```javascript
const body = `{
  "theme": "instance-default"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com', {
  method: 'PUT',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "theme": "instance-default"
}'''

response = requests.put(
    'https://peertube2.cpy.re/api/v1/player-settings/video-channels/my_username%20%7C%20my_username%40example.com',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```
